//+------------------------------------------------------------------+
//|                            Bollinger bands stop - EMA deviations |
//|                                                           mladen |
//| idea for Bollinger bands stop by igorad                          |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Ccurrent time frame";
extern int    BandsPeriod     = 20;
extern double BandsDeviation  = 2.0;
extern double MoneyRisk       = 1.0;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;

//
//
//
//
//

double TrendU[];
double TrendD[];
double trend[];
double buffers[][5];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0, TrendU); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, TrendD); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, trend);

   //
   //
   //
   //
   //

      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

   //
   //
   //
   //
   //

   IndicatorShortName(timeFrameToString(timeFrame)+" EMA deviations bands stop ("+BandsPeriod+","+DoubleToStr(BandsDeviation,2)+")");
return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { TrendU[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period()) { CalculateBBStops(limit);  return(0); }
         
   //
   //
   //
   //
   //
         
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         TrendU[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsDeviation,MoneyRisk,0,y);
         TrendD[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsDeviation,MoneyRisk,1,y);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsDeviation,MoneyRisk,2,y);
   }
   manageAlerts();
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define _trend 0
#define _smax  1
#define _smin  2
#define _bmax  3
#define _bmin  4

//
//
//
//
//

void CalculateBBStops(int limit)
{
   if (ArrayRange(buffers,0) != Bars) ArrayResize(buffers,Bars);
   int i,r;
 
   //
   //
   //
   //
   //
      
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double ma     = iMA(NULL,0,BandsPeriod,0,MODE_SMA,PRICE_CLOSE,i);
      double stdDev = iEDev(Close[i],BandsPeriod,i)*BandsDeviation;

      //
      //
      //
      //
      //

      buffers[r][_smax]  = ma+stdDev;
      buffers[r][_smin]  = ma-stdDev;
      buffers[r][_trend] = buffers[r-1][_trend];

               if (Close[i]>buffers[r-1][_smax]) buffers[r][_trend]= 1;
               if (Close[i]<buffers[r-1][_smin]) buffers[r][_trend]=-1;

      if (buffers[r][_trend]>0) buffers[r][_smin] = MathMax(buffers[r][_smin],buffers[r-1][_smin]);
      if (buffers[r][_trend]<0) buffers[r][_smax] = MathMin(buffers[r][_smax],buffers[r-1][_smax]);
                                buffers[r][_bmax] = buffers[r][_smax]+(MoneyRisk-1.0)*stdDev;
                                buffers[r][_bmin] = buffers[r][_smin]-(MoneyRisk-1.0)*stdDev;
      if (buffers[r][_trend]>0) buffers[r][_bmin] = MathMax(buffers[r][_bmin],buffers[r-1][_bmin]);
      if (buffers[r][_trend]<0) buffers[r][_bmax] = MathMin(buffers[r][_bmax],buffers[r-1][_bmax]);

      //
      //
      //
      //
      //
         
      TrendU[i] = EMPTY_VALUE;
      TrendD[i] = EMPTY_VALUE;
      trend[i]  = buffers[r][_trend]; 
         
      if (buffers[r][_trend]>0) TrendU[i] = 1;
      else                      TrendD[i] = 1;
   }
   manageAlerts();
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double edevWork[][2];
double iEDev(double price,double period, int i)
{
   if (ArrayRange(edevWork,0)!=Bars) ArrayResize(edevWork,Bars);
   
   int    r     = Bars-i-1;
   double alpha = 2.0/(1.0+period);
      
      edevWork[r][0] = edevWork[r-1][0]+alpha*(price      -edevWork[r-1][0]);
      edevWork[r][1] = edevWork[r-1][1]+alpha*(price*price-edevWork[r-1][1]);
         
   return(MathSqrt(period*(edevWork[r][1]-edevWork[r][0]*edevWork[r][0])/(period-1.0)));
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," BB stops trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"BB stops"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}